/* -*- C++ -*- */
/**
 *  @file   EC_Group_Scheduling.h
 *
 *  $Id: EC_Group_Scheduling.h 76589 2007-01-25 18:04:11Z elliott_c $
 *
 *  @author Carlos O'Ryan (coryan@cs.wustl.edu)
 *
 * Based on previous work by Tim Harrison (harrison@cs.wustl.edu) and
 * other members of the DOC group. More details can be found in:
 *
 * http://doc.ece.uci.edu/~coryan/EC/index.html
 */

#ifndef TAO_EC_GROUP_SCHEDULING_H
#define TAO_EC_GROUP_SCHEDULING_H
#include /**/ "ace/pre.h"

#include "orbsvcs/Event/EC_Scheduling_Strategy.h"

#if !defined (ACE_LACKS_PRAGMA_ONCE)
# pragma once
#endif /* ACE_LACKS_PRAGMA_ONCE */

/**
 * @class TAO_EC_Group_Scheduling
 *
 * @brief A scheduling strategy that preserves event groups.
 */
class TAO_RTEvent_Serv_Export TAO_EC_Group_Scheduling : public TAO_EC_Scheduling_Strategy
{
public:
  /// Constructor.
  TAO_EC_Group_Scheduling (void);

  // Read EC_Scheduling_Strategy.h for more details
  virtual void add_proxy_supplier_dependencies (
      TAO_EC_ProxyPushSupplier *supplier,
      TAO_EC_ProxyPushConsumer *consumer);
  virtual void schedule_event (const RtecEventComm::EventSet &event,
                               TAO_EC_ProxyPushConsumer *consumer,
                               TAO_EC_Supplier_Filter *filter);

private:
  TAO_EC_Group_Scheduling (const TAO_EC_Group_Scheduling&);
  TAO_EC_Group_Scheduling& operator= (const TAO_EC_Group_Scheduling&);
};

#if defined (__ACE_INLINE__)
#include "orbsvcs/Event/EC_Group_Scheduling.inl"
#endif /* __ACE_INLINE__ */

#include /**/ "ace/post.h"
#endif /* TAO_EC_GROUP_SCHEDULING_H */
